org.optaplanner.core.config.heuristic.selector.move.composite

## Class UnionMoveSelectorConfig

- java.lang.Object
- - org.optaplanner.core.config.AbstractConfig<C>
  - - org.optaplanner.core.config.heuristic.selector.SelectorConfig<C>
    - - org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig<UnionMoveSelectorConfig>
      - - org.optaplanner.core.config.heuristic.selector.move.composite.UnionMoveSelectorConfig

-     public class UnionMoveSelectorConfig
      extends MoveSelectorConfig<UnionMoveSelectorConfig>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `cacheType, filterClassList, probabilityWeightFactoryClass, selectedCountLimit, selectionOrder, sorterClass, sorterComparatorClass, sorterOrder, sorterWeightFactoryClass`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UnionMoveSelectorConfig()`
    `UnionMoveSelectorConfig(List<MoveSelectorConfig> moveSelectorConfigList)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MoveSelector` | `buildBaseMoveSelector(HeuristicConfigPolicy configPolicy, SelectionCacheType minimumCacheType, boolean randomSelection)`
    `UnionMoveSelectorConfig` | `copyConfig()` Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
    `void` | `extractLeafMoveSelectorConfigsIntoList(List<MoveSelectorConfig> leafMoveSelectorConfigList)` Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
    `List<MoveSelectorConfig>` | `getMoveSelectorConfigList()`
    `Class<? extends SelectionProbabilityWeightFactory>` | `getSelectorProbabilityWeightFactoryClass()`
    `UnionMoveSelectorConfig` | `inherit(UnionMoveSelectorConfig inheritedConfig)` Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).
    `void` | `setMoveSelectorConfigList(List<MoveSelectorConfig> moveSelectorConfigList)`
    `void` | `setSelectorProbabilityWeightFactoryClass(Class<? extends SelectionProbabilityWeightFactory> selectorProbabilityWeightFactoryClass)`
    `String` | `toString()`

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `buildMoveSelector, buildUnfoldedMoveSelectorConfig, determineBaseRandomSelection, getCacheType, getFilterClassList, getFixedProbabilityWeight, getProbabilityWeightFactoryClass, getSelectedCountLimit, getSelectionOrder, getSorterClass, getSorterComparatorClass, getSorterOrder, getSorterWeightFactoryClass, inheritFolded, isBaseInherentlyCached, setCacheType, setFilterClassList, setFixedProbabilityWeight, setProbabilityWeightFactoryClass, setSelectedCountLimit, setSelectionOrder, setSorterClass, setSorterComparatorClass, setSorterOrder, setSorterWeightFactoryClass, withCacheType, withFilterClassList, withFixedProbabilityWeight, withProbabilityWeightFactoryClass, withSelectedCountLimit, withSelectionOrder, withSorterClass, withSorterComparatorClass, withSorterOrder, withSorterWeightFactoryClass`

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.SelectorConfig

      `validateCacheTypeVersusSelectionOrder`

    - ### Methods inherited from class org.optaplanner.core.config.AbstractConfig

      `deduceEntityDescriptor, deduceVariableDescriptor, deduceVariableDescriptorList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### UnionMoveSelectorConfig

          public UnionMoveSelectorConfig()

    - #### UnionMoveSelectorConfig

          public UnionMoveSelectorConfig(List<MoveSelectorConfig> moveSelectorConfigList)

  - ### Method Detail

    - #### getMoveSelectorConfigList

          public List<MoveSelectorConfig> getMoveSelectorConfigList()

    - #### setMoveSelectorConfigList

          public void setMoveSelectorConfigList(List<MoveSelectorConfig> moveSelectorConfigList)

    - #### getSelectorProbabilityWeightFactoryClass

          public Class<? extends SelectionProbabilityWeightFactory> getSelectorProbabilityWeightFactoryClass()

    - #### setSelectorProbabilityWeightFactoryClass

          public void setSelectorProbabilityWeightFactoryClass(Class<? extends SelectionProbabilityWeightFactory> selectorProbabilityWeightFactoryClass)

    - #### buildBaseMoveSelector

          public MoveSelector buildBaseMoveSelector(HeuristicConfigPolicy configPolicy,
                                                    SelectionCacheType minimumCacheType,
                                                    boolean randomSelection)

      Specified by:
        `buildBaseMoveSelector` in class `MoveSelectorConfig<UnionMoveSelectorConfig>`
      Parameters:
        `configPolicy` - never null
        `minimumCacheType` - never null, If caching is used (different from `SelectionCacheType.JUST_IN_TIME`), then it should be at least this `SelectionCacheType` because an ancestor already uses such caching and less would be pointless.
        `randomSelection` - true is equivalent to `SelectionOrder.RANDOM`, false is equivalent to `SelectionOrder.ORIGINAL`
      Returns:
        never null

    - #### extractLeafMoveSelectorConfigsIntoList

          public void extractLeafMoveSelectorConfigsIntoList(List<MoveSelectorConfig> leafMoveSelectorConfigList)

      Description copied from class: `MoveSelectorConfig`
      Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
      Overrides:
        `extractLeafMoveSelectorConfigsIntoList` in class `MoveSelectorConfig<UnionMoveSelectorConfig>`
      Parameters:
        `leafMoveSelectorConfigList` - not null

    - #### inherit

          public UnionMoveSelectorConfig inherit(UnionMoveSelectorConfig inheritedConfig)

      Description copied from class: `AbstractConfig`
      Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).

      After the inheritance, if a property on this `AbstractConfig` composition is replaced, it should not affect the inherited composition instance.

      Overrides:
        `inherit` in class `MoveSelectorConfig<UnionMoveSelectorConfig>`
      Parameters:
        `inheritedConfig` - never null
      Returns:
        this

    - #### copyConfig

          public UnionMoveSelectorConfig copyConfig()

      Description copied from class: `AbstractConfig`
      Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
      Specified by:
        `copyConfig` in class `AbstractConfig<UnionMoveSelectorConfig>`
      Returns:
        new instance

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractConfig<UnionMoveSelectorConfig>`

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.